package com.qmth.distributed.print.business.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.distributed.print.business.entity.BasicAttachment;
import com.qmth.distributed.print.business.enums.UploadFileEnum;
import org.springframework.web.multipart.MultipartFile;

/**
 * <p>
 * 所有附件记录表 服务类
 * </p>
 *
 * @author xf
 * @since 2021-03-23
 */
public interface BasicAttachmentService extends IService<BasicAttachment> {

    BasicAttachment save(MultipartFile file, String md5, Long schoolId, Long userId);

    /**
     * 保存附件
     *
     * @param file
     * @param md5
     * @param type
     * @return
     */
    public BasicAttachment saveAttachment(MultipartFile file, String md5, UploadFileEnum type);

    /**
     * 保存附件
     *
     * @param file
     * @param md5
     * @param type
     * @param objId
     * @return
     */
    public BasicAttachment saveAttachment(MultipartFile file, String md5, UploadFileEnum type, Long objId);

    /**
     * 删除附件
     *
     * @param tbAttachment
     */
    public void deleteAttachment(BasicAttachment tbAttachment);
}
