package com.qmth.distributed.print.business.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.distributed.print.business.bean.dto.ExamTaskDetailDto;
import com.qmth.distributed.print.business.entity.ExamDetail;
import com.qmth.distributed.print.business.entity.ExamPrintPlan;

import java.util.Map;

/**
 * <p>
 * 考务数据 服务类
 * </p>
 *
 * @author xf
 * @since 2021-03-23
 */
public interface ExamDetailService extends IService<ExamDetail> {
    /**
     * 计算印刷计划下的总科次
     * @param printPlanId 印刷计划id
     * @return 该印刷计划下总科次
     */
    double calculateTotalSubjects(Long printPlanId);

    /**
     * 计算印刷计划下的总卷袋数
     * @param printPlanId 印刷计划id
     * @return 该印刷计划下总卷袋数
     */
    double calculateTotalPackages(Long printPlanId);

    IPage<ExamTaskDetailDto> listPrintTask(Long schoolId, String printPlanName, String status, String courseCode, String paperNumber, String examPlace, Long examStartTime, Long examEndTime, Integer pageNumber, Integer pageSize);

    Map<String, Object> taskTotalData(String printPlanName, String status, String courseCode, String paperNumber, String examPlace, Long examStartTime, Long examEndTime);

    String taskViewPDF(Long id);
}
