package com.qmth.distributed.print.business.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.distributed.print.business.bean.dto.ExamTaskDetailDto;
import com.qmth.distributed.print.business.bean.params.ExamCardParams;
import com.qmth.distributed.print.business.entity.ExamTaskDetail;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 命题任务明细表（入库申请） 服务类
 * </p>
 *
 * @author xf
 * @since 2021-03-23
 */
public interface ExamTaskDetailService extends IService<ExamTaskDetail> {

    boolean enable(ExamTaskDetail examTaskDetail);

    boolean updatePaper(Map<String, String> map);

    IPage<ExamTaskDetailDto> list(Long schoolId, String relateType, Long printPlanId, String courseCode, String paperNumber, Integer pageNumber, Integer pageSize);

    List<ExamTaskDetail> listByCardId(Long cardId);

    void bindCardId(String examTaskId, Long cardId);

    void resetCardId(Long id);
}
